//IMDTablerServlet.java:  Servlet interface for IMDTabler.
//
//  7/20/2016 -- [ET]
//

package com.etheli.imdtabler;

import java.io.PrintWriter;
import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
 
/**
 * Class IMDTablerServlet is a servlet interface for IMDTabler.
 */
public class IMDTablerServlet extends HttpServlet
{
  private static final long serialVersionUID = -5589513354107195913L;

  @Override
   public void doGet(HttpServletRequest request, HttpServletResponse response)
               throws IOException, ServletException
   {
      // Set the response message's MIME type
      response.setContentType("text/html;charset=UTF-8");
      // Allocate a output writer to write the response message into the network socket
      PrintWriter out = response.getWriter();
 
      // Write the response message, in an HTML page
      try
      {
         out.println("<!DOCTYPE html");  // HTML 5
         out.println("<html><head>");
         out.println("<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>");
         out.println("<head><title>IMDTabler</title></head>");
         out.println("<body>");
         out.println("<h3>IMDTabler - Intermodulation Distortion Table Generator</h3>");

         out.println("For info on IMD, see <a href=\"http://www.rcgroups.com/forums/showthread.php?t=2447038\"");
         out.println("target=\"_blank\">here</a>, <a href=\"http://forum.multigp.com/forum/event-race-management/186-frequency-profiles-what-they-actually-mean\"");
         out.println("target=\"_blank\">here</a>, <a href=\"http://www.nwfpv.com/the-lounge/189-5-8ghz-fpv-distortion-imd-intermodulation-distortion.html\"");
         out.println("target=\"_blank\">here</a>, and <a href=\"http://www.youtube.com/watch?v=axWXu8ih8Oc\" target=\"_blank\">video here</a>.");

         out.println("Sample frequency sets:<br />");
         out.println("<a href=\"run?freq_values=5665+5725+5820+5860+5945\">ET 5 (best yet)</a>: 5665 5725 5820 5860 5945<br />");
         out.println("<a href=\"run?freq_values=5645+5740+5820+5860+5945\">IMD 5B</a>: 5645 5740 5820 5860 5945, <a href=\"run?freq_values=5685+5760+5800+5860+5905\">IMD 5</a>: 5685 5760 5800 5860 5905<br />");
         out.println("<a href=\"run?freq_values=5645+5685+5760+5800+5860\">IMD 5A</a>:  5645 5685 5760 5800 5860, <a href=\"run?freq_values=5645+5685+5760+5800+5860+5905\">IMD 6</a>: 5645 5685 5760 5800 5860 5905<br />");
         out.println("<a href=\"run?freq_values=5658+5695+5732+5769+5806+5843+5880+5917\">raceband</a>:  5658 5695 5732 5769 5806 5843 5880 5917, <a href=\"run?freq_values=5780+5860+5945\">Freq in YT video</a>:  5780 5860 5945<br />");
         out.println("<a href=\"run?freq_values=5665+5740+5843+5945\">Sat-0716</a>:  5665 5740 5843 5945, <a href=\"run?freq_values=5665+5740+5828+5945\">Sat-0716_mod</a>:  5665 5740 5828 5945<br />");
         out.println("<br />");
 
         // Return the existing session if there is one. Otherwise, create a new session
//         HttpSession session = request.getSession();
 
         // Display session information
//         out.println("sessions.id" + " " + session.getId() + "<br />");
//         out.println("sessions.created" + " ");
//         out.println(new Date(session.getCreationTime()) + "<br />");
//         out.println("sessions.lastaccessed" + " ");
//         out.println(new Date(session.getLastAccessedTime()) + "<br /><br />");
 
         // Set an attribute (name-value pair) if present in the request
//         String attName = request.getParameter("attribute_name");
//         if (attName != null) attName = attName.trim();
//         String attValue = request.getParameter("attribute_value");
//         if (attValue != null) attValue = attValue.trim();
//         if (attName != null && !attName.equals("")
//               && attValue != null && !attValue.equals("") )
//         {
//            // synchronized session object to prevent concurrent update
//            synchronized(session)
//            {
//               session.setAttribute(attName, attValue);
//            }
//         }
 
         // Display the attributes (name-value pairs) stored in this session
//         out.println("sessions.data" + "<br>");
//         Enumeration names = session.getAttributeNames();
//         while (names.hasMoreElements())
//         {
//             String name = (String) names.nextElement();
//             String value = session.getAttribute(name).toString();
//             out.println(HtmlFilter.filter(name) + " = "
//                   + HtmlFilter.filter(value) + "<br>");
//         }
//         out.println("<br />");
 
         // Display a form to prompt user to create session attribute
         out.println("<form method='get'>");
         out.println("Enter frequencies: ");
         out.println("<input type='text' name='freq_values' size='50'> ");
         out.println("<input type='submit' value='Run'>");
         out.println("</form>");
 
//         out.print("<a href='");
//         // Encode URL by including the session ID (URL-rewriting)
//         out.print(response.encodeURL(request.getRequestURI() + "?attribute_name=foo&attribute_value=bar"));
//         out.println("'>Encode URL with session ID (URL re-writing)</a>");
//         out.println("</body></html>");
         
         String freqValuesStr = request.getParameter("freq_values");
         if(freqValuesStr != null &&
                          (freqValuesStr=freqValuesStr.trim()).length() > 0)
         {
           out.println("(Hover the mouse cursor over table cells for information)<br /><br />");
           out.println(IMDTabler.getIMDStringForFreqSet(freqValuesStr));
         }
         
         out.println("<br /><hr /><br />");
         out.println("<a href=\"http://www.etheli.com/freq/FPV_5.8GHz_Freqs.jpg\"");
         out.println("target=\"_blank\">5.8GHz FPV \"Visual\" Frequency Chart</a><br /><br />");
         out.println("Click <a href=\"http://www.etheli.com/contact/index.html\">here to contact me</a><br /><br />");
         out.println("<a href=\"http://www.etheli.com\">Back to etheli.com home page</a>");
         
      }
      finally
      {
         out.close();  // Always close the output writer
      }
   }
 
   // Do the same thing for GET and POST requests
   @Override
   public void doPost(HttpServletRequest request, HttpServletResponse response)
         throws IOException, ServletException
   {
      doGet(request, response);
   }
}
